#include <math.h>
#include "common.h"
#include "softiic.h"

int sda_pin=0; // GPIO0
int scl_pin=1; // GPIO1
// 软件 I2C 延时
void i2c_delay() {
    delayMicroseconds(5);
}

// I2C 起始信号
void i2c_start(int sda_pin, int scl_pin) {
    digitalWrite(sda_pin, HIGH);
    digitalWrite(scl_pin, HIGH);
    i2c_delay();
    digitalWrite(sda_pin, LOW);
    i2c_delay();
    digitalWrite(scl_pin, LOW);
    i2c_delay();
}

// I2C 停止信号
void i2c_stop(int sda_pin, int scl_pin) {
    digitalWrite(sda_pin, LOW);
    digitalWrite(scl_pin, LOW);
    i2c_delay();
    digitalWrite(scl_pin, HIGH);
    i2c_delay();
    digitalWrite(sda_pin, HIGH);
    i2c_delay();
}

// I2C 发送一个字节
void i2c_write_byte(int sda_pin, int scl_pin, uint8_t data) {
    for (int i = 7; i >= 0; i--) {
        digitalWrite(sda_pin, (data >> i) & 0x01);
        i2c_delay();
        digitalWrite(scl_pin, HIGH);
        i2c_delay();
        digitalWrite(scl_pin, LOW);
        i2c_delay();
    }
    // 接收 ACK
    pinMode(sda_pin, INPUT);
    digitalWrite(scl_pin, HIGH);
    i2c_delay();
    digitalWrite(scl_pin, LOW);
    pinMode(sda_pin, OUTPUT);
}

// I2C 读取一个字节
uint8_t i2c_read_byte(int sda_pin, int scl_pin, bool ack) {
    uint8_t data = 0;
    pinMode(sda_pin, INPUT);
    for (int i = 7; i >= 0; i--) {
        digitalWrite(scl_pin, HIGH);
        i2c_delay();
        data |= (digitalRead(sda_pin) << i);
        digitalWrite(scl_pin, LOW);
        i2c_delay();
    }
    // 发送 ACK/NACK
    pinMode(sda_pin, OUTPUT);
    digitalWrite(sda_pin, ack ? LOW : HIGH);
    digitalWrite(scl_pin, HIGH);
    i2c_delay();
    digitalWrite(scl_pin, LOW);
    pinMode(sda_pin, INPUT);
    return data;
}